#lang racket

;;;; 5. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 15.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - univerzálna funkcia pre primitívne rekurzívne funkcie,
;;;; - výroková logika.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 3
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 20.3.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (iter f n x)
  (if (= n 0) x (iter f (- n 1) (f x))))

(define (each? p? xs)
  (if (null? xs) #t (and (p? (car xs)) (each? p? (cdr xs)))))

(define (natural-number? x)
  (exact-nonnegative-integer? x))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Primitívne rekurzívne funkcie.

;;; Sekcia. Univerzálna funkcia pre primitívne rekurzívne funkcie.

;;; Podsekcia. Aritmetizácia primitívne rekurzívnych funkčných symbolov.

;; Konštruktory.

(define Zx (list 'Zx))                     ; konštantná funkcia λx.0
(define Sx (list 'Sx))                     ; funkcia nasledovníka λx.x+1
(define (Ix n i) (list 'Ix n i))           ; identity (projekcie)
(define (Px g gs) (list 'Px g gs))         ; kontrakcia
(define (Cx n m h gs) (list 'Cx n m h gs)) ; kompozícia
(define (Rx n g h) (list 'Rx n g h))       ; primitívna rekurzia

;; Predikáty.

(define (Zx? e) (equal? (list-ref e 0) 'Zx))
(define (Sx? e) (equal? (list-ref e 0) 'Sx))
(define (Ix? e) (equal? (list-ref e 0) 'Ix))
(define (Px? e) (equal? (list-ref e 0) 'Px))
(define (Cx? e) (equal? (list-ref e 0) 'Cx))
(define (Rx? e) (equal? (list-ref e 0) 'Rx))

;; Selektory.

(define (Ix-arity e) (list-ref e 1))
(define (Ix-i e) (list-ref e 2))

(define (Px-g e) (list-ref e 1))
(define (Px-gs e) (list-ref e 2))

(define (Cx-arity e) (list-ref e 1))
(define (Cx-h-arity e) (list-ref e 2))
(define (Cx-h e) (list-ref e 3))
(define (Cx-gs e) (list-ref e 4))

(define (Rx-arity e) (list-ref e 1))
(define (Rx-g e) (list-ref e 2))
(define (Rx-h e) (list-ref e 3))

;; Údajový typ pre primitívne rekurzívne funkčné symboly.

(define (PRFS? e)
  (and (list? e)
       (>= (length e) 1)
       (or (and (Zx? e)
                (= (length e) 1))
           (and (Sx? e)
                (= (length e) 1))
           (and (Ix? e)
                (= (length e) 3)
                (natural-number? (Ix-arity e))
                (natural-number? (Ix-i e)))
           (and (Px? e)
                (= (length e) 3)
                (PRFS? (Px-g e))
                (PRFS? (Px-gs e)))
           (and (Cx? e)
                (= (length e) 5)
                (natural-number? (Cx-arity e))
                (natural-number? (Cx-h-arity e))
                (PRFS? (Cx-h e))
                (PRFS? (Cx-gs e)))
           (and (Rx? e)
                (= (length e) 4)
                (natural-number? (Cx-arity e))
                (PRFS? (Rx-g e))
                (PRFS? (Rx-h e))))))

;; Predikát p.r.-function-symbol?(n,e) platí, ak číslo e je kódom n-árneho
;; primitívne rekurzívneho funkčného symbolu.

(define (p.r.-function-symbol? n e)
  (define (is-p.r.-function-symbol? n e)
    (or (and (Zx? e)
             (= n 1))
        (and (Sx? e)
             (= n 1))
        (and (Ix? e)
             (= (Ix-arity e) n)
             (<= 1 (Ix-i e))
             (<= (Ix-i e) n))
        (and (Cx? e)
             (= (Cx-arity e) n)
             (>= (Cx-h-arity e) 1)
             (is-p.r.-function-symbol? (Cx-h-arity e) (Cx-h e))
             (are-p.r.-function-symbols? n (Cx-gs e) (Cx-h-arity e)))
        (and (Rx? e)
             (= (Rx-arity e) n)
             (>= n 2)
             (is-p.r.-function-symbol? (- n 1) (Rx-g e))
             (is-p.r.-function-symbol? (+ n 1) (Rx-h e)))))
  (define (are-p.r.-function-symbols? n e k)
    (or (and (= k 1)
             (is-p.r.-function-symbol? n e))
        (and (> k 1)
             (Px? e)
             (is-p.r.-function-symbol? n (Px-g e))
             (are-p.r.-function-symbols? n (Px-gs e) (- k 1)))))
  (and (PRFS? e) (>= n 1) (is-p.r.-function-symbol? n e)))

;; Arita primitívne rekurzívnych funkčných symbolov.

(define (arity e)
  (cond [(Zx? e) 1]
        [(Sx? e) 1]
        [(Ix? e) (Ix-arity e)]
        [(Cx? e) (Cx-arity e)]
        [(Rx? e) (Rx-arity e)]))

;;; Podsekcia. Interpreter primitívne rekurzívnych funkčných symbolov.

;; (prémia 3 body)
;; Úloha. Zostrojte interpreter primitívne rekurzívnych funkčných symbolov.

(define (interpreter e x) ...)

;; Podsekcia. Primitívne rekurzívne indexy.

;; Definícia. Ak platí predikát p.r.-function-symbol?(n,e), tak vravíme, že
;; číslo e je dobre vytvorený primitívne rekurzívny index n-árnej primitívne
;; rekurzívnej funkcie.

;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre konštantnú
;; funkciu λx.1.

(define ⌜λx.1⌝ ...)

;; (PRFS? ⌜λx.1⌝)
;; (p.r.-function-symbol? 1 ⌜λx.1⌝)
;; (query (λ (x) (interpreter ⌜λx.1⌝ x)) 0 10)

;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre konštantnú
;; funkciu λx.2.

(define ⌜λx.2⌝ ...)

;; (PRFS? ⌜λx.2⌝)
;; (p.r.-function-symbol? 1 ⌜λx.2⌝)
;; (query (λ (x) (interpreter ⌜λx.2⌝ x)) 0 10)

;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre konštantnú
;; funkciu λx.3.

(define ⌜λx.3⌝ ...)

;; (PRFS? ⌜λx.3⌝)
;; (p.r.-function-symbol? 1 ⌜λx.3⌝)
;; (query (λ (x) (interpreter ⌜λx.3⌝ x)) 0 10)

;; (1 bod)
;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre binárnu
;; konštantnú funkciu λxy.3.

(define ⌜λxy.3⌝ ...)

;; (PRFS? ⌜λxy.3⌝)
;; (p.r.-function-symbol? 2 ⌜λxy.3⌝)
;; (query (λ (x) (interpreter ⌜λxy.3⌝ (cons x 5))) 0 10)

;; (1 bod)
;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre sčítanie.

(define ⌜+⌝ ...)

;; (PRFS? ⌜+⌝)
;; (p.r.-function-symbol? 2 ⌜+⌝)
;; (query (λ (x) (interpreter ⌜+⌝ (cons x 5))) 0 10)

;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre násobenie.

(define ⌜×⌝ ...)

;; (PRFS? ⌜×⌝)
;; (p.r.-function-symbol? 2 ⌜×⌝)
;; (query (λ (x) (interpreter ⌜×⌝ (cons x 5))) 0 10)

;; (1 bod)
;; Úloha. Zostrojte dobre vytvorený primitívne rekurzívny index pre operáciu
;; umocňovania.

(define ⌜exp⌝ ...)

;; (PRFS? ⌜exp⌝)
;; (p.r.-function-symbol? 2 ⌜exp⌝)
;; (query (λ (x) (interpreter ⌜exp⌝ (cons 2 x))) 0 10)
