#lang racket

(require "mauxb.rkt")

;;;; 5. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 15.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - univerzálna funkcia pre primitívne rekurzívne funkcie,
;;;; - výroková logika.
;;;; Zadanie sa skladá z týchto súborov:
;;;; - Súbory maux*.rkt obsahujú definície pomocných funkcií a predikátov. 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 0
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 5
;;;; Odovzdať do 3.4.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (compose f g) (λ (x) (g (f x))))

(define (each? p? xs)
  (if (null? xs) #t (and (p? (car xs)) (each? p? (cdr xs)))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Výroková logika.

;;; Sekcia. Jazyk výrokovej logiky.

;; [Lisp] Pozri modul v súbore mauxb.rkt.

;;; Sekcia. Sémantika výrokovej logiky.

;; Definícia. Formula je tautológia, ak je pravdivá pri každom
;; výrokovo-logickom ohodnoteni.

;; Príklad. Nasledujúce formuly sú tautológie.

(define A1 (IFF (OR (VAR 1) (AND (VAR 2) (VAR 3))) (AND (OR (VAR 1) (VAR 2)) (OR (VAR 1) (VAR 3)))))
(define A2 (IMP (AND (IMP (VAR 1) (VAR 2)) (IMP (VAR 2) (VAR 3))) (IMP (VAR 1) (VAR 3))))
(define A3 (IFF (IMP (VAR 1) (VAR 2)) (IMP (NOT (VAR 2)) (NOT (VAR 1)))))
(define A4 (IFF (IFF (VAR 1) (VAR 2)) (IMP (OR (VAR 1) (VAR 2)) (AND (VAR 1) (VAR 2)))))
(define A5 (IMP (VAR 1) (IMP (VAR 2) (VAR 1))))
(define A6 (IMP (AND (AND (IMP (VAR 1) (VAR 3)) (IMP (VAR 2) (VAR 3))) (OR (VAR 1) (VAR 2))) (VAR 3)))
(define A7 (IFF (NOT (IMP (VAR 1) (VAR 2))) (AND (VAR 1) (NOT (VAR 2)))))

;; Príklad. Nasledujúce formuly nie sú tautológie.

(define B1 (IMP (OR (VAR 1) (VAR 2)) (AND (VAR 1) (VAR 2))))
(define B2 (IFF (IMP (VAR 1) (VAR 2)) (IMP (VAR 2) (VAR 1))))
(define B3 (IMP (IMP (VAR 1) (VAR 2)) (IMP (NOT (VAR 1)) (NOT (VAR 2)))))
(define B4 (IMP (IMP (AND (VAR 1) (VAR 2)) (VAR 3)) (AND (IMP (VAR 1) (VAR 3)) (IMP (VAR 2) (VAR 3)))))

;;; Sekcia. Rozpoznávanie tautológií.

;; (projekt 5 bodov)
;; Úloha. Zostrojte program, ktorý s pomocou sekventového kalkulu urči, či daná
;; formula je tautológia.

(define (tautology? a) ...)

;; (tautology? A1)
;; (each? tautology? (list A1 A2 A3 A4 A5 A6 A7))
;; (not (tautology? B1))
;; (each? (compose tautology? not) (list B1 B2 B3 B4))
